package com.zksy.data.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zksy.data.annotation.XhDataLogRecord;
import com.zksy.data.domain.po.XcrOtherInfo39;
import com.zksy.data.domain.response.XcrOtherInfo39Response;
import com.zksy.data.mapper.XcrOtherInfo39Mapper;
import com.zksy.data.service.XcrOtherInfo39Service;
import com.zksy.data.utils.RedisService;
import com.zksy.data.utils.XhRequestUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;
import java.util.List;
import java.util.Vector;

/**
* @author Administrator
* @description 针对表【xcr_other_info_39(农业主体信息表)】的数据库操作Service实现
* @createDate 2024-10-15 11:21:16
*/
@Service
@Slf4j
public class XcrOtherInfo39ServiceImpl extends ServiceImpl<XcrOtherInfo39Mapper, XcrOtherInfo39>
    implements XcrOtherInfo39Service{
    @Autowired
    private XhRequestUtil xhRequestUtil;
    @Autowired
    private RedisService redisService;
    @Override
    @Transactional(rollbackFor = Exception.class)
    @XhDataLogRecord("同步农业主体信息")
    public void saveDataByUniCode(String address) {
        //模拟从数据库中取数据大约为3000-4000条
        List<String> creditCodes = (List<String>) redisService.getList("creditCodes").get(0);
        Vector<XcrOtherInfo39> toDatabaseList = new Vector<>();
        List<String> inventoryList = List.of("39");
        inventoryList.parallelStream().forEach(inventory -> {
            creditCodes.parallelStream().forEach(creditCode -> {
                HashMap<String, String> requestbodyMap = new HashMap<>();
                requestbodyMap.put("entityCode", creditCode);
                requestbodyMap.put("size", String.valueOf(10));
                requestbodyMap.put("page", String.valueOf(1));
                requestbodyMap.put("inventoryId", inventory);
                try {
                    List<XcrOtherInfo39> list = xhRequestUtil.requestXinyonghuanhuai2(requestbodyMap,address,
                            XcrOtherInfo39Response.class,
                            XcrOtherInfo39.class);
                    if(list != null){
                        toDatabaseList.addAll(list);
                    }
                } catch (Exception e) {
                    List<XcrOtherInfo39> list = xhRequestUtil.requestXinyonghuanhuai2(requestbodyMap,address,
                            XcrOtherInfo39Response.class,
                            XcrOtherInfo39.class);
                    if(list != null){
                        toDatabaseList.addAll(list);
                    }
                }
            });
            log.info("inventorywe为:{}完成",inventory);
        });
        this.remove(null);
        this.saveBatch(toDatabaseList);
        log.info("农业主体清单表同步完成");
    }
}




